DCMTK Version 3.7.0 OFFIS DICOM Toolkit

Classes | Public Member Functions | Protected Member Functions | Static Protected Member Functions | Protected Attributes | Private Attributes | List of all members
DcmObject Class Referenceabstract

Abstract base class for most classes in module dcmdata. More...

Inheritance diagram for DcmObject:

## Classes
class | PrintHelper
| helper class to print a DcmObject to an ostream using operator<< More...

## Public Member Functions
| DcmObject (const DcmTag &tag, const Uint32 len=0)
| constructor. More...
| DcmObject (const DcmObject &obj)
| copy constructor More...
virtual | ~DcmObject ()
| destructor
virtual DcmObject * | clone () const =0
| clone method More...
DcmObject & | operator= (const DcmObject &obj)
| copy assignment operator More...
virtual OFCondition | copyFrom (const DcmObject &rhs)=0
| Virtual object copying. More...
virtual DcmEVR | ident () const =0
| return identifier for this class. More...
DcmEVR | getVR () const
| return the value representation assigned to this object. More...
OFBool | isaString () const
| check if this element is a string type, based on the VR. More...
virtual OFBool | isLeaf () const =0
| check if this element is a leaf node in a dataset tree. More...
virtual OFBool | isElement () const
| check if this element can be safely casted to DcmElement More...
virtual OFBool | isNested () const
| check if this element is nested in a sequence of items, i.e. not a top-level or stand-alone element More...
virtual void | print (STD_NAMESPACE ostream &out, const size_t flags=0, const int level=0, const char *pixelFileName=NULL, size_t *pixelCounter=NULL)=0
| print object to a stream More...
E_TransferState | transferState () const
| return the current transfer (read/write) state of this object. More...
virtual void | transferInit (void)
| initialize the transfer state of this object. More...
virtual void | transferEnd (void)
| finalize the transfer state of this object. More...
DcmItem * | getRootItem ()
| get root dataset/item (top-level) that contains this object. More...
virtual DcmItem * | getParentItem ()
| get parent item of this object. More...
DcmObject * | getParent ()
| get parent of this object. More...
const DcmObject * | getParent () const
| get parent of this object. More...
void | setParent (DcmObject *parent)
| set parent of this object. More...
Uint16 | getGTag () const
| return the group number of the attribute tag for this object More...
Uint16 | getETag () const
| return the element number of the attribute tag for this object More...
const DcmTag & | getTag () const
| return const reference to the attribute tag for this object More...
void | setGTag (Uint16 gtag)
| assign group tag (but not element tag) of the attribute tag for this object. More...
virtual OFCondition | setVR (DcmEVR vr)
| assign a new Value Representation (VR) to this object. More...
virtual unsigned long | getVM ()=0
| get value multiplicity of this object. More...
virtual unsigned long | getNumberOfValues ()=0
| get number of values stored in this object More...
virtual Uint32 | calcElementLength (const E_TransferSyntax xfer, const E_EncodingType enctype)=0
| calculate the length of this DICOM element when encoded with the given transfer syntax and the given encoding type for sequences. More...
virtual Uint32 | getLength (const E_TransferSyntax xfer=EXS_LittleEndianImplicit, const E_EncodingType enctype=EET_UndefinedLength)=0
| calculate the value length (without attribute tag, VR and length field) of this DICOM element when encoded with the given transfer syntax and the given encoding type for sequences. More...
virtual OFBool | canWriteXfer (const E_TransferSyntax newXfer, const E_TransferSyntax oldXfer)=0
| check if this DICOM object can be encoded in the given transfer syntax. More...
virtual OFCondition | read (DcmInputStream &inStream, const E_TransferSyntax ixfer, const E_GrpLenEncoding glenc=EGL_noChange, const Uint32 maxReadLength=DCM_MaxReadLength)=0
| read object from a stream. More...
virtual OFCondition | write (DcmOutputStream &outStream, const E_TransferSyntax oxfer, const E_EncodingType enctype, DcmWriteCache *wcache)=0
| write object to a stream (abstract) More...
virtual OFCondition | writeXML (STD_NAMESPACE ostream &out, const size_t flags=0)
| write object in XML format to a stream More...
virtual OFCondition | writeJson (STD_NAMESPACE ostream &out, DcmJsonFormat &format)
| write object in JSON format to a stream More...
virtual OFCondition | writeSignatureFormat (DcmOutputStream &outStream, const E_TransferSyntax oxfer, const E_EncodingType enctype, DcmWriteCache *wcache)=0
| special write method for creation of digital signatures (abstract) More...
virtual OFBool | isSignable () const
| returns true if the current object may be included in a digital signature More...
virtual OFBool | containsUnknownVR () const
| returns true if the object contains an element with Unknown VR at any nesting level More...
virtual OFBool | containsExtendedCharacters (const OFBool checkAllStrings=OFFalse)
| check if this object contains non-ASCII characters More...
virtual OFBool | isAffectedBySpecificCharacterSet () const
| check if this object is affected by SpecificCharacterSet More...
virtual OFCondition | convertCharacterSet (DcmSpecificCharacterSet &converter)
| convert this object from the currently selected source character set to the currently selected destination character set (if affected by SpecificCharacterSet) More...
virtual OFBool | isEmpty (const OFBool normalize=OFTrue)
| check if this object is empty More...
virtual OFCondition | clear ()=0
| clear (remove) attribute value More...
virtual OFCondition | verify (const OFBool autocorrect=OFFalse)=0
| check the currently stored element value More...
virtual DcmObject * | nextInContainer (const DcmObject *obj)
| this method is only used in container classes derived from this class, that is, DcmItem and DcmSequenceOfItems. More...
virtual OFCondition | nextObject (DcmStack &stack, const OFBool intoSub)
| this method enables a stack based, depth-first traversal of a complete hierarchical DICOM dataset (that is, classes derived from DcmItem or DcmSequenceOfItems). More...
virtual OFCondition | search (const DcmTagKey &xtag, DcmStack &resultStack, E_SearchMode mode=ESM_fromHere, OFBool searchIntoSub=OFTrue)
| a complex, stack-based, hierarchical search method. More...
virtual OFCondition | loadAllDataIntoMemory ()=0
| this method loads all attribute values maintained by this object and all sub-objects (in case of a container such as DcmDataset) into memory. More...
Uint32 | getLengthField () const
| return the current value of the Length field (which is different from the functionality of the public getLength() method). More...

## Protected Member Functions
void | printNestingLevel (STD_NAMESPACE ostream &out, const size_t flags, const int level)
| print line indentation, e.g. a couple of spaces for each nesting level. More...
void | printInfoLineStart (STD_NAMESPACE ostream &out, const size_t flags, const int level, DcmTag *tag=NULL)
| print beginning of the info line. More...
void | printInfoLineEnd (STD_NAMESPACE ostream &out, const size_t flags, const unsigned long printedLength=0xffffffff, DcmTag *tag=NULL)
| print end of the info line. More...
virtual void | printInfoLine (STD_NAMESPACE ostream &out, const size_t flags, const int level=0, const char *info=NULL, DcmTag *tag=NULL, const OFBool isInfo=OFTrue)
| print given text with element information. More...
virtual OFCondition | writeTagAndLength (DcmOutputStream &outStream, const E_TransferSyntax oxfer, Uint32 &writtenBytes) const
| write tag, VR and length field to the given output stream More...
virtual Uint32 | getTagAndLengthSize (const E_TransferSyntax oxfer) const
| return the number of bytes needed to serialize the tag, VR and length information of the current object using the given transfer syntax. More...
const char * | getTagName ()
| return the DICOM attribute tag name for this object. More...
void | setTagVR (DcmEVR vr)
| set the VR for this attribute More...
E_TransferState | getTransferState () const
| return the current transfer state of this object during serialization/deserialization More...
void | setTransferState (E_TransferState newState)
| set the current transfer state of this object during serialization/deserialization More...
Uint32 | getTransferredBytes () const
| return the number of transferred bytes for this object during serialization/deserialization More...
void | setTransferredBytes (Uint32 val)
| set the number of transferred bytes for this object during serialization/deserialization More...
void | incTransferredBytes (Uint32 val)
| add to the number of transferred bytes for this object during serialization/deserialization More...
void | setLengthField (Uint32 val)
| set the current value of the Length field More...

## Static Protected Member Functions
static OFCondition | writeTag (DcmOutputStream &outStream, const DcmTag &tag, const E_TransferSyntax oxfer)
| static helper function that writes a given attribute tag to a binary output stream using the byte order indicated by the transfer syntax. More...

## Protected Attributes
OFCondition | errorFlag
| error flag for this object.

## Private Attributes
DcmTag | Tag
| the DICOM attribute tag and VR for this object
Uint32 | Length
| the length of this attribute as read from stream, may be undefined length
E_TransferState | fTransferState
| transfer state during read and write operations
Uint32 | fTransferredBytes
| number of bytes already read/written during transfer
DcmObject * | Parent
| pointer to parent object if contained in a dataset/item (might be NULL)

## Detailed Description

Abstract base class for most classes in module dcmdata.

As a rule of thumb, everything that is either a dataset or that can be identified with a DICOM attribute tag is derived from class DcmObject.

## Constructor & Destructor Documentation

## ◆ DcmObject() [1/2]

DcmObject::DcmObject | ( | const DcmTag & | tag,
|  | const Uint32 | len = `0`
| ) |  |

constructor.

Create new object from given tag and length.

Parameters

  tag | DICOM tag for the new element
  len | value length for the new element

## ◆ DcmObject() [2/2]

DcmObject::DcmObject | ( | const DcmObject & | obj | ) |

copy constructor

Parameters

  obj | item to be copied

## Member Function Documentation

## ◆ calcElementLength()

virtual Uint32 DcmObject::calcElementLength | ( | const E_TransferSyntax | xfer,
|  | const E_EncodingType | enctype
| ) |  |
| pure virtual

calculate the length of this DICOM element when encoded with the given transfer syntax and the given encoding type for sequences.

For elements, the length includes the length of the tag, length field, VR field and the value itself, for items and sequences it returns the length of the complete item or sequence including delimitation tags if applicable.

Warning
  Since calcElementLength() returns a 32 bit integer, an overflow during calculation is possible for some derived classes that actually represent a compound value (e.g. items like DcmPixelItem). Such overflows will be detected, in which case the maximum possible value will be returned instead, coinciding with DCM_UndefinedLength.
  The implementation in DcmPixelData may return zero if no conforming representation exists and set the EC_RepresentationNotFound error flag to indicated it.
  When calculation the length of a sequence or an item containing multiple attributes, the implementation may return DCM_UndefinedLength to indicate a value that can not be encoded as a 32 bit length field. It will even do so if "dcmWriteOversizedSeqsAndItemsUndefined" is disabled, but then also set the EC_SeqOrItemContentOverflow error flag (inside getLength()) to indicated it.

Note
  Just check for zero or DCM_UndefinedLength return value and then have a look at the error flag in either case.

Parameters

  xfer | transfer syntax for length calculation
  enctype | sequence encoding type for length calculation

Returns
  length of DICOM element

Implemented in DcmSequenceOfItems, DcmPixelItem, DcmPixelSequence, DcmPixelData, DcmMetaInfo, DcmItem, DcmFileFormat, DcmElement, and DcmDataset.

## ◆ canWriteXfer()

virtual OFBool DcmObject::canWriteXfer | ( | const E_TransferSyntax | newXfer,
|  | const E_TransferSyntax | oldXfer
| ) |  |
| pure virtual

check if this DICOM object can be encoded in the given transfer syntax.

Parameters

  newXfer | transfer syntax in which the DICOM object is to be encoded
  oldXfer | transfer syntax in which the DICOM object was read or created.

Returns
  true if object can be encoded in desired transfer syntax, false otherwise.

Implemented in DcmSequenceOfItems, DcmFileFormat, DcmDataset, DcmOtherByteOtherWord, DcmPixelSequence, DcmPixelData, DcmItem, and DcmElement.

## ◆ clear()

virtual OFCondition DcmObject::clear | ( |  | ) |
| pure virtual

clear (remove) attribute value

Returns
  EC_Normal if successful, an error code otherwise

Implemented in DcmUnsignedLongOffset, DcmSequenceOfItems, DcmItem, DcmFileFormat, DcmElement, DcmDataset, and DcmByteString.

## ◆ clone()

virtual DcmObject* DcmObject::clone | ( |  | ) | const
| pure virtual

clone method

Returns
  deep copy of this object

Implemented in DcmUnsigned64bitVeryLong, DcmUnlimitedText, DcmUnsignedShort, DcmUniversalResourceIdentifierOrLocator, DcmUnsignedLongOffset, DcmUnsignedLong, DcmUniqueIdentifier, DcmUnlimitedCharacters, DcmTime, DcmSigned64bitVeryLong, DcmShortText, DcmSignedShort, DcmSignedLong, DcmShortString, DcmPolymorphOBOW, DcmPersonName, DcmOther64bitVeryLong, DcmOtherLong, DcmOtherFloat, DcmOtherDouble, DcmOtherByteOtherWord, DcmLongText, DcmLongString, DcmIntegerString, DcmFloatingPointSingle, DcmFloatingPointDouble, DcmDateTime, DcmDecimalString, DcmDate, DcmCodeString, DcmAttributeTag, DcmAgeString, DcmApplicationEntity, DcmSequenceOfItems, DcmPixelItem, DcmPixelSequence, DcmPixelData, DcmOverlayData, DcmMetaInfo, DcmItem, DcmFileFormat, DcmDirectoryRecord, DcmDataset, DcmCharString, and DcmByteString.

## ◆ containsExtendedCharacters()

virtual OFBool DcmObject::containsExtendedCharacters | ( | const OFBool | checkAllStrings = `OFFalse` | ) |
| virtual

check if this object contains non-ASCII characters

Parameters

  checkAllStrings | not used in this class

Returns
  always returns false, i.e. no extended characters used

Reimplemented in DcmSequenceOfItems, DcmItem, DcmCharString, and DcmByteString.

## ◆ containsUnknownVR()

virtual OFBool DcmObject::containsUnknownVR | ( |  | ) | const
| virtual

returns true if the object contains an element with Unknown VR at any nesting level

Returns
  true if the object contains an element with Unknown VR, false otherwise

Reimplemented in DcmSequenceOfItems, and DcmItem.

## ◆ convertCharacterSet()

virtual OFCondition DcmObject::convertCharacterSet | ( | DcmSpecificCharacterSet & | converter | ) |
| virtual

convert this object from the currently selected source character set to the currently selected destination character set (if affected by SpecificCharacterSet)

Parameters

  converter | character set converter to be used to convert the element values

Returns
  always returns EC_Normal, since there is nothing to do in this base class

Reimplemented in DcmSequenceOfItems, DcmItem, DcmFileFormat, DcmDirectoryRecord, and DcmCharString.

## ◆ copyFrom()

virtual OFCondition DcmObject::copyFrom | ( | const DcmObject & | rhs | ) |
| pure virtual

Virtual object copying.

This method can be used for DcmObject and derived classes to get a deep copy of an object. Internally the assignment operator is called if the given DcmObject parameter is of the same type as "this" object instance. If not, an error is returned. This function permits copying an object by value in a virtual way which therefore is different to just calling the assignment operator of DcmElement which could result in slicing the object.

Parameters

  rhs | - [in] The instance to copy from. Has to be of the same class type as "this" object

Returns
  EC_Normal if copying was successful, error otherwise

Implemented in DcmUnsigned64bitVeryLong, DcmUnlimitedText, DcmUnsignedShort, DcmUniversalResourceIdentifierOrLocator, DcmUnsignedLongOffset, DcmUnsignedLong, DcmUniqueIdentifier, DcmUnlimitedCharacters, DcmTime, DcmSigned64bitVeryLong, DcmShortText, DcmSignedShort, DcmSignedLong, DcmShortString, DcmPolymorphOBOW, DcmPersonName, DcmOther64bitVeryLong, DcmOtherLong, DcmOtherFloat, DcmOtherDouble, DcmOtherByteOtherWord, DcmLongText, DcmLongString, DcmIntegerString, DcmFloatingPointSingle, DcmFloatingPointDouble, DcmDateTime, DcmDecimalString, DcmDate, DcmCodeString, DcmAttributeTag, DcmAgeString, DcmApplicationEntity, DcmSequenceOfItems, DcmPixelItem, DcmPixelSequence, DcmPixelData, DcmOverlayData, DcmMetaInfo, DcmItem, DcmFileFormat, DcmElement, DcmDirectoryRecord, DcmDataset, DcmCharString, and DcmByteString.

## ◆ getETag()

Uint16 DcmObject::getETag | ( |  | ) | const
| inline

return the element number of the attribute tag for this object

Returns
  element number of the attribute tag for this object

## ◆ getGTag()

Uint16 DcmObject::getGTag | ( |  | ) | const
| inline

return the group number of the attribute tag for this object

Returns
  group number of the attribute tag for this object

## ◆ getLength()

virtual Uint32 DcmObject::getLength | ( | const E_TransferSyntax | xfer = `EXS_LittleEndianImplicit`,
|  | const E_EncodingType | enctype = `EET_UndefinedLength`
| ) |  |
| pure virtual

calculate the value length (without attribute tag, VR and length field) of this DICOM element when encoded with the given transfer syntax and the given encoding type for sequences.

Never returns undefined length.

Parameters

  xfer | transfer syntax for length calculation
  enctype | sequence encoding type for length calculation

Returns
  value length of DICOM element

Implemented in DcmSequenceOfItems, DcmPixelData, DcmItem, DcmElement, and DcmByteString.

## ◆ getLengthField()

Uint32 DcmObject::getLengthField | ( |  | ) | const
| inline

return the current value of the Length field (which is different from the functionality of the public getLength() method).

Only needed for internal purposes and for checker tools that verify values against the length field.

Returns
  current value of length field

Referenced by DcmElement::getLength(), and DcmElement::valueLoaded().

## ◆ getNumberOfValues()

virtual unsigned long DcmObject::getNumberOfValues | ( |  | ) |
| pure virtual

get number of values stored in this object

Returns
  number of values in this object

Implemented in DcmUnsigned64bitVeryLong, DcmUnsignedShort, DcmUnsignedLong, DcmSigned64bitVeryLong, DcmSignedShort, DcmSignedLong, DcmOtherByteOtherWord, DcmFloatingPointSingle, DcmFloatingPointDouble, DcmAttributeTag, DcmSequenceOfItems, DcmItem, and DcmByteString.

Referenced by DcmIODUtil::copyFromUint8Array().

## ◆ getParent() [1/2]

DcmObject* DcmObject::getParent | ( |  | ) |
| inline

get parent of this object.

If this object is an element that has been inserted into a dataset/item, the parent is this particular dataset/item. If this object is an item that has been inserted into a sequence, the parent is this particular sequence. If this object has not been inserted into a dataset/item or sequence, NULL is returned.

Returns
  pointer to the parent of this object (might be NULL)

## ◆ getParent() [2/2]

const DcmObject* DcmObject::getParent | ( |  | ) | const
| inline

get parent of this object.

If this object is an element that has been inserted into a dataset/item, the parent is this particular dataset/item. If this object is an item that has been inserted into a sequence, the parent is this particular sequence. If this object has not been inserted into a dataset/item or sequence, NULL is returned.

Returns
  pointer to the parent of this object (might be NULL)

## ◆ getParentItem()

virtual DcmItem* DcmObject::getParentItem | ( |  | ) |
| virtual

get parent item of this object.

In case of a top-level element, this is either the main dataset or the file meta-information. In case of a nested element, this is the surrounding item.

Returns
  pointer to the parent item of this object (might be NULL)

Reimplemented in DcmPixelItem, and DcmItem.

## ◆ getRootItem()

DcmItem* DcmObject::getRootItem | ( |  | ) |

get root dataset/item (top-level) that contains this object.

Internally, the list of parent pointers is followed in order to find the root. If this object has no parent item, a pointer to this object is returned instead.

Returns
  pointer to the root dataset/item (might be NULL)

## ◆ getTag()

const DcmTag& DcmObject::getTag | ( |  | ) | const
| inline

return const reference to the attribute tag for this object

Returns
  const reference to the attribute tag for this object

## ◆ getTagAndLengthSize()

virtual Uint32 DcmObject::getTagAndLengthSize | ( | const E_TransferSyntax | oxfer | ) | const
| protected virtual

return the number of bytes needed to serialize the tag, VR and length information of the current object using the given transfer syntax.

Parameters

  oxfer | The transfer syntax used for encoding

Returns
  number of bytes, may be 8 or 12 depending on VR and transfer syntax.

## ◆ getTagName()

const char* DcmObject::getTagName | ( |  | ) |
| inline protected

return the DICOM attribute tag name for this object.

If not known yet, will be looked up in the dictionary and cached. Therefore, method is not const.

Returns
  tag name for this attribute

## ◆ getTransferredBytes()

Uint32 DcmObject::getTransferredBytes | ( |  | ) | const
| inline protected

return the number of transferred bytes for this object during serialization/deserialization

Returns
  number of transferred bytes

## ◆ getTransferState()

E_TransferState DcmObject::getTransferState | ( |  | ) | const
| inline protected

return the current transfer state of this object during serialization/deserialization

Returns
  current transfer state of this object

## ◆ getVM()

virtual unsigned long DcmObject::getVM | ( |  | ) |
| pure virtual

get value multiplicity of this object.

Please note that depending on the Value Representation (VR), subclasses derived from this class either return the number of currently stored values or the constant value 1 (as defined in the DICOM standard). See getNumberOfValues(), which always returns the number of stored values.

Returns
  value multiplicity of this object

Implemented in DcmUnsigned64bitVeryLong, DcmUnlimitedText, DcmUnsignedShort, DcmUniversalResourceIdentifierOrLocator, DcmUnsignedLong, DcmSigned64bitVeryLong, DcmShortText, DcmSignedShort, DcmSignedLong, DcmOther64bitVeryLong, DcmOtherLong, DcmOtherFloat, DcmOtherDouble, DcmOtherByteOtherWord, DcmLongText, DcmFloatingPointSingle, DcmFloatingPointDouble, DcmAttributeTag, DcmSequenceOfItems, DcmItem, and DcmByteString.

## ◆ getVR()

DcmEVR DcmObject::getVR | ( |  | ) | const
| inline

return the value representation assigned to this object.

If object was read from a stream, this method returns the VR that was defined in the stream for this object. It is, therefore, possible that the VR does not match the one defined in the data dictionary for the tag assigned to this object.

Returns
  VR of this object

## ◆ ident()

virtual DcmEVR DcmObject::ident | ( |  | ) | const
| pure virtual

return identifier for this class.

Every class derived from this class returns a unique value of type enum DcmEVR for this call. This is used as a "poor man's RTTI" to correctly identify instances derived from this class even on compilers not supporting RTTI.

Returns
  type identifier of this class

Implemented in DcmFloatingPointSingle, DcmAgeString, DcmPixelItem, DcmPixelSequence, DcmUnsigned64bitVeryLong, DcmUnlimitedText, DcmUnsignedShort, DcmUniversalResourceIdentifierOrLocator, DcmUnsignedLongOffset, DcmUnsignedLong, DcmUniqueIdentifier, DcmUnlimitedCharacters, DcmTime, DcmSigned64bitVeryLong, DcmShortText, DcmSignedShort, DcmSignedLong, DcmShortString, DcmPersonName, DcmOther64bitVeryLong, DcmOtherLong, DcmOtherFloat, DcmOtherDouble, DcmOtherByteOtherWord, DcmLongText, DcmLongString, DcmIntegerString, DcmFloatingPointDouble, DcmDateTime, DcmDecimalString, DcmDate, DcmCodeString, DcmAttributeTag, DcmApplicationEntity, DcmSequenceOfItems, DcmPixelData, DcmOverlayData, DcmMetaInfo, DcmItem, DcmFileFormat, DcmDirectoryRecord, DcmDataset, and DcmByteString.

Referenced by DcmOverlayData::copyFrom().

## ◆ incTransferredBytes()

void DcmObject::incTransferredBytes | ( | Uint32 | val | ) |
| inline protected

add to the number of transferred bytes for this object during serialization/deserialization

Parameters

  val | number of additional transferred bytes to add to existing value

## ◆ isAffectedBySpecificCharacterSet()

virtual OFBool DcmObject::isAffectedBySpecificCharacterSet | ( |  | ) | const
| virtual

check if this object is affected by SpecificCharacterSet

Returns
  always returns false, i.e. not affected by SpecificCharacterSet

Reimplemented in DcmSequenceOfItems, DcmItem, DcmCharString, and DcmByteString.

## ◆ isaString()

OFBool DcmObject::isaString | ( |  | ) | const
| inline

check if this element is a string type, based on the VR.

Since the check is based on the VR and not on the class, the result of this method is not a guarantee that the object can be safely casted to one of the string-VR subclasses.

Returns
  true if this object is a string VR, false otherwise

## ◆ isElement()

virtual OFBool DcmObject::isElement | ( |  | ) | const
| inline virtual

check if this element can be safely casted to DcmElement

Returns
  true if DcmElement, false otherwise

Reimplemented in DcmElement.

## ◆ isEmpty()

virtual OFBool DcmObject::isEmpty | ( | const OFBool | normalize = `OFTrue` | ) |
| virtual

check if this object is empty

Parameters

  normalize | normalize value before checking (ignore non-significant characters)

Returns
  true if object is empty, i.e. has no value, false otherwise

Reimplemented in DcmSequenceOfItems, DcmItem, and DcmByteString.

## ◆ isLeaf()

virtual OFBool DcmObject::isLeaf | ( |  | ) | const
| pure virtual

check if this element is a leaf node in a dataset tree.

All subclasses of DcmElement except for DcmSequenceOfItems are leaf nodes, while DcmSequenceOfItems, DcmItem, DcmDataset etc. are not.

Returns
  true if leaf node, false otherwise

Implemented in DcmSequenceOfItems, DcmItem, and DcmElement.

## ◆ isNested()

virtual OFBool DcmObject::isNested | ( |  | ) | const
| virtual

check if this element is nested in a sequence of items, i.e. not a top-level or stand-alone element

Returns
  true if this element is nested, false otherwise

Reimplemented in DcmPixelItem, and DcmItem.

## ◆ isSignable()

virtual OFBool DcmObject::isSignable | ( |  | ) | const
| virtual

returns true if the current object may be included in a digital signature

Returns
  true if signable, false otherwise

Reimplemented in DcmSequenceOfItems.

## ◆ loadAllDataIntoMemory()

virtual OFCondition DcmObject::loadAllDataIntoMemory | ( |  | ) |
| pure virtual

this method loads all attribute values maintained by this object and all sub-objects (in case of a container such as DcmDataset) into memory.

After a call to this method, the file from which a dataset was read may safely be deleted or replaced. For large files, this method may obviously allocate large amounts of memory.

Returns
  EC_Normal if successful, an error code otherwise

Implemented in DcmSequenceOfItems, DcmPixelData, DcmItem, and DcmElement.

## ◆ nextInContainer()

virtual DcmObject* DcmObject::nextInContainer | ( | const DcmObject * | obj | ) |
| virtual

this method is only used in container classes derived from this class, that is, DcmItem and DcmSequenceOfItems.

It returns a pointer to the next object in the list AFTER the given object. If the caller passes NULL, a pointer to the first object in the list is returned. If the given object is not found, the given object is the last one in the list or the list is empty, NULL is returned.

Parameters

  obj | pointer to one object in the container; we are looking for the next entry after this one. NULL if looking for the first entry.

Returns
  pointer to next object in container or NULL if not found

Reimplemented in DcmSequenceOfItems, and DcmItem.

## ◆ nextObject()

virtual OFCondition DcmObject::nextObject | ( | DcmStack & | stack,
|  | const OFBool | intoSub
| ) |  |
| virtual

this method enables a stack based, depth-first traversal of a complete hierarchical DICOM dataset (that is, classes derived from DcmItem or DcmSequenceOfItems).

With each call of this method, the next object in the tree is located and marked on the stack.

Parameters

  stack | "cursor" for current position in the dataset. The stack will contain a pointer to each dataset, sequence, item and element from the main dataset down to the current element, and is updated upon each call to this method. An empty stack is equivalent to a stack containing a pointer to this object only.
  intoSub | if true, the nextObject method will perform a hierarchical search through the dataset (depth-first), if false, only the current container object will be traversed (e.g., all elements of an item or all items of a sequence).

Returns
  EC_Normal if value length is correct, an error code otherwise

Reimplemented in DcmSequenceOfItems, and DcmItem.

## ◆ operator=()

DcmObject& DcmObject::operator= | ( | const DcmObject & | obj | ) |

copy assignment operator

Parameters

  obj | object to be copied

Returns
  reference to this object

## ◆ print()

virtual void DcmObject::print | ( | STD_NAMESPACE ostream & | out,
|  | const size_t | flags = `0`,
|  | const int | level = `0`,
|  | const char * | pixelFileName = `NULL`,
|  | size_t * | pixelCounter = `NULL`
| ) |  |
| pure virtual

print object to a stream

Parameters

  out | output stream
  flags | optional flag used to customize the output (see DCMTypes::PF_xxx)
  level | current level of nested items. Used for indentation.
  pixelFileName | not used (used in certain sub-classes of this class)
  pixelCounter | not used (used in certain sub-classes of this class)

Implemented in DcmUnsigned64bitVeryLong, DcmUnsignedShort, DcmUnsignedLong, DcmUniqueIdentifier, DcmSigned64bitVeryLong, DcmSignedShort, DcmSignedLong, DcmOtherByteOtherWord, DcmFloatingPointSingle, DcmFloatingPointDouble, DcmAttributeTag, DcmSequenceOfItems, DcmPixelItem, DcmPixelSequence, DcmPixelData, DcmMetaInfo, DcmItem, DcmFileFormat, DcmDirectoryRecord, DcmDataset, and DcmByteString.

Referenced by operator<<().

## ◆ printInfoLine()

virtual void DcmObject::printInfoLine | ( | STD_NAMESPACE ostream & | out,
|  | const size_t | flags,
|  | const int | level = `0`,
|  | const char * | info = `NULL`,
|  | DcmTag * | tag = `NULL`,
|  | const OFBool | isInfo = `OFTrue`
| ) |  |
| protected virtual

print given text with element information.

Calls printInfoLineStart() and printInfoLineEnd() to frame the 'info' text.

Parameters

  out | output stream
  flags | used to customize the output (see DCMTypes::PF_xxx)
  level | current level of nested items. Used for indentation.
  info | text to be printed
  tag | optional tag used to print the data element information
  isInfo | optional flag indicating whether this text is really given for informational purposes only. Used to choose the correct output color.

## ◆ printInfoLineEnd()

void DcmObject::printInfoLineEnd | ( | STD_NAMESPACE ostream & | out,
|  | const size_t | flags,
|  | const unsigned long | printedLength = `0xffffffff`,
|  | DcmTag * | tag = `NULL`
| ) |  |
| protected

print end of the info line.

The default output is length, value multiplicity and tag name, though other visualizations are possible depending on the value of 'flags'.

Parameters

  out | output stream
  flags | used to customize the output (see DCMTypes::PF_xxx)
  printedLength | number of characters printed after line start. Used for padding purposes.
  tag | optional tag used to print the data element information

## ◆ printInfoLineStart()

void DcmObject::printInfoLineStart | ( | STD_NAMESPACE ostream & | out,
|  | const size_t | flags,
|  | const int | level,
|  | DcmTag * | tag = `NULL`
| ) |  |
| protected

print beginning of the info line.

The default output is tag and value representation, though other visualizations are possible depending on the value of 'flags'.

Parameters

  out | output stream
  flags | used to customize the output (see DCMTypes::PF_xxx)
  level | current level of nested items. Used for indentation.
  tag | optional tag used to print the data element information

## ◆ printNestingLevel()

void DcmObject::printNestingLevel | ( | STD_NAMESPACE ostream & | out,
|  | const size_t | flags,
|  | const int | level
| ) |  |
| protected

print line indentation, e.g. a couple of spaces for each nesting level.

Depending on the value of 'flags' other visualizations are also possible.

Parameters

  out | output stream
  flags | used to customize the output (see DCMTypes::PF_xxx)
  level | current level of nested items. Used for indentation.

## ◆ read()

virtual OFCondition DcmObject::read | ( | DcmInputStream & | inStream,
|  | const E_TransferSyntax | ixfer,
|  | const E_GrpLenEncoding | glenc = `EGL_noChange`,
|  | const Uint32 | maxReadLength = `DCM_MaxReadLength`
| ) |  |
| pure virtual

read object from a stream.

Parameters

  inStream | DICOM input stream
  ixfer | transfer syntax to use when parsing
  glenc | handling of group length parameters
  maxReadLength | attribute values larger than this value are skipped while parsing and read later upon first access if the stream type supports this.

Returns
  EC_Normal if successful, an error code otherwise

Implemented in DcmMetaInfo, DcmFileFormat, DcmDataset, DcmSequenceOfItems, DcmDirectoryRecord, DcmPixelSequence, DcmPixelData, DcmItem, DcmElement, and DcmPolymorphOBOW.

## ◆ search()

virtual OFCondition DcmObject::search | ( | const DcmTagKey & | xtag,
|  | DcmStack & | resultStack,
|  | E_SearchMode | mode = `ESM_fromHere`,
|  | OFBool | searchIntoSub = `OFTrue`
| ) |  |
| virtual

a complex, stack-based, hierarchical search method.

It allows for a search for a DICOM object with a given attribute within a given container, hierarchically, from a starting position identified through a cursor stack.

Parameters

  xtag | the DICOM attribute tag we are searching for
  resultStack | Depending on the search mode (see below), this parameter either serves as an input and output parameter, or as an output parameter only (the latter being the default). When used as an input parameter, the cursor stack defines the start position for the search within a hierarchical DICOM dataset. Upon successful return, the stack contains the position of the element found, in the form of a pointer to each dataset, sequence, item and element from the main dataset down to the found element.
  mode | search mode, controls how the search stack is handled. In the default mode, ESM_fromHere, the stack is ignored on input, and the search starts in the object for which this method is called. In the other modes, the stack is used both as an input and an output parameter and defines the starting point for the search.
  searchIntoSub | if true, the search will be performed hierarchically descending into the sequences and items of the dataset. If false, only the current container (sequence or item) will be traversed.

Returns
  EC_Normal if found, EC_TagNotFound if not found, an error code is something went wrong.

Reimplemented in DcmSequenceOfItems, DcmItem, and DcmDirectoryRecord.

## ◆ setGTag()

void DcmObject::setGTag | ( | Uint16 | gtag | ) |
| inline

assign group tag (but not element tag) of the attribute tag for this object.

This is sometimes useful when creating repeating group elements.

Parameters

  gtag | new attribute group tag

## ◆ setLengthField()

void DcmObject::setLengthField | ( | Uint32 | val | ) |
| inline protected

set the current value of the Length field

Parameters

  val | new value of the Length field

## ◆ setParent()

void DcmObject::setParent | ( | DcmObject * | parent | ) |
| inline

set parent of this object.

NULL means no parent. NB: This method is used by derived classes for internal purposes only.

Parameters

  parent | pointer to the parent of this object

## ◆ setTagVR()

void DcmObject::setTagVR | ( | DcmEVR | vr | ) |
| inline protected

set the VR for this attribute

Parameters

  vr | new VR for this attribute.

## ◆ setTransferredBytes()

void DcmObject::setTransferredBytes | ( | Uint32 | val | ) |
| inline protected

set the number of transferred bytes for this object during serialization/deserialization

Parameters

  val | number of transferred bytes

## ◆ setTransferState()

void DcmObject::setTransferState | ( | E_TransferState | newState | ) |
| inline protected

set the current transfer state of this object during serialization/deserialization

Parameters

  newState | new transfer state of this object

## ◆ setVR()

virtual OFCondition DcmObject::setVR | ( | DcmEVR | vr | ) |
| inline virtual

assign a new Value Representation (VR) to this object.

This operation is only supported for very few subclasses derived from this class, in particular for classes handling pixel data which may either be of OB or OW value representation.

Parameters

  vr | value representation

Returns
  EC_Normal if successful, an error code otherwise

Reimplemented in DcmOtherByteOtherWord, and DcmPixelData.

References EC_IllegalCall.

## ◆ transferEnd()

virtual void DcmObject::transferEnd | ( | void |  | ) |
| virtual

finalize the transfer state of this object.

This method must be called when reading/writing this object from/to a stream has been completed.

Reimplemented in DcmPolymorphOBOW, DcmSequenceOfItems, DcmPixelData, DcmMetaInfo, and DcmItem.

## ◆ transferInit()

virtual void DcmObject::transferInit | ( | void |  | ) |
| virtual

initialize the transfer state of this object.

This method must be called before this object is written to a stream or read (parsed) from a stream.

Reimplemented in DcmPolymorphOBOW, DcmSequenceOfItems, DcmPixelData, DcmMetaInfo, DcmItem, and DcmElement.

## ◆ transferState()

E_TransferState DcmObject::transferState | ( |  | ) | const
| inline

return the current transfer (read/write) state of this object.

Returns
  transfer state of this object

## ◆ verify()

virtual OFCondition DcmObject::verify | ( | const OFBool | autocorrect = `OFFalse` | ) |
| pure virtual

check the currently stored element value

Parameters

  autocorrect | correct value length if OFTrue

Returns
  status, EC_Normal if value length is correct, an error code otherwise

Implemented in DcmUnsigned64bitVeryLong, DcmUnsignedShort, DcmUnsignedLongOffset, DcmUnsignedLong, DcmSigned64bitVeryLong, DcmSignedShort, DcmSignedLong, DcmOtherByteOtherWord, DcmFloatingPointSingle, DcmFloatingPointDouble, DcmAttributeTag, DcmSequenceOfItems, DcmItem, DcmDirectoryRecord, DcmCharString, and DcmByteString.

## ◆ write()

virtual OFCondition DcmObject::write | ( | DcmOutputStream & | outStream,
|  | const E_TransferSyntax | oxfer,
|  | const E_EncodingType | enctype,
|  | DcmWriteCache * | wcache
| ) |  |
| pure virtual

write object to a stream (abstract)

Parameters

  outStream | DICOM output stream
  oxfer | output transfer syntax
  enctype | encoding types (undefined or explicit length)
  wcache | pointer to write cache object, may be NULL

Returns
  status, EC_Normal if successful, an error code otherwise

Implemented in DcmPolymorphOBOW, DcmOtherByteOtherWord, DcmSequenceOfItems, DcmPixelSequence, DcmPixelData, DcmMetaInfo, DcmItem, DcmFileFormat, DcmElement, DcmDataset, and DcmByteString.

## ◆ writeJson()

virtual OFCondition DcmObject::writeJson | ( | STD_NAMESPACE ostream & | out,
|  | DcmJsonFormat & | format
| ) |  |
| virtual

write object in JSON format to a stream

Parameters

  out | output stream to which the JSON document is written
  format | used to format and customize the output

Returns
  status, always returns EC_Illegal Call

Reimplemented in DcmUnsigned64bitVeryLong, DcmSigned64bitVeryLong, DcmShortString, DcmPersonName, DcmOther64bitVeryLong, DcmOtherLong, DcmOtherFloat, DcmOtherDouble, DcmOtherByteOtherWord, DcmLongString, DcmIntegerString, DcmFloatingPointSingle, DcmFloatingPointDouble, DcmDecimalString, DcmAttributeTag, DcmSequenceOfItems, DcmPixelSequence, DcmPixelData, DcmMetaInfo, DcmItem, DcmFileFormat, DcmElement, DcmDataset, DcmCharString, and DcmByteString.

## ◆ writeSignatureFormat()

virtual OFCondition DcmObject::writeSignatureFormat | ( | DcmOutputStream & | outStream,
|  | const E_TransferSyntax | oxfer,
|  | const E_EncodingType | enctype,
|  | DcmWriteCache * | wcache
| ) |  |
| pure virtual

special write method for creation of digital signatures (abstract)

Parameters

  outStream | DICOM output stream
  oxfer | output transfer syntax
  enctype | encoding types (undefined or explicit length)
  wcache | pointer to write cache object, may be NULL

Returns
  status, EC_Normal if successful, an error code otherwise

Implemented in DcmPolymorphOBOW, DcmOtherByteOtherWord, DcmSequenceOfItems, DcmPixelItem, DcmPixelSequence, DcmPixelData, DcmItem, DcmElement, DcmDataset, and DcmByteString.

## ◆ writeTag()

static OFCondition DcmObject::writeTag | ( | DcmOutputStream & | outStream,
|  | const DcmTag & | tag,
|  | const E_TransferSyntax | oxfer
| ) |  |
| static protected

static helper function that writes a given attribute tag to a binary output stream using the byte order indicated by the transfer syntax.

Parameters

  outStream | output stream
  tag | tag to write to the stream
  oxfer | transfer syntax defining the byte order

Returns
  EC_Normal if successful, an error code otherwise

## ◆ writeTagAndLength()

virtual OFCondition DcmObject::writeTagAndLength | ( | DcmOutputStream & | outStream,
|  | const E_TransferSyntax | oxfer,
|  | Uint32 & | writtenBytes
| ) |  | const
| protected virtual

write tag, VR and length field to the given output stream

Parameters

  outStream | output stream
  oxfer | transfer syntax for writing
  writtenBytes | number of bytes written to stream returned in this parameter

Returns
  EC_Normal if successful, an error code otherwise

Reimplemented in DcmPixelItem.

## ◆ writeXML()

virtual OFCondition DcmObject::writeXML | ( | STD_NAMESPACE ostream & | out,
|  | const size_t | flags = `0`
| ) |  |
| virtual

write object in XML format to a stream

Parameters

  out | output stream to which the XML document is written
  flags | optional flag used to customize the output (see DCMTypes::XF_xxx)

Returns
  status, always returns EC_Illegal Call

Reimplemented in DcmPersonName, DcmOther64bitVeryLong, DcmOtherLong, DcmOtherFloat, DcmOtherDouble, DcmOtherByteOtherWord, DcmDecimalString, DcmAttributeTag, DcmSequenceOfItems, DcmPixelItem, DcmPixelSequence, DcmPixelData, DcmMetaInfo, DcmItem, DcmFileFormat, DcmElement, DcmDirectoryRecord, and DcmDataset.

The documentation for this class was generated from the following file:

- dcmdata/include/dcmtk/dcmdata/dcobject.h

Generated on Mon Dec 15 2025 for DCMTK Version 3.7.0 by Doxygen 1.9.1